import * as React from 'react';
import { findAll } from './highlight';

import IHighlighter, { HighlighterProps } from './types'

const Highlighter: IHighlighter<HighlighterProps> = ({
  textToHighlight,
  activeClasses,
  words,
  autoEscape = true
}) => {
  const textChunks = findAll({
    textToHighlight: textToHighlight,
    activeClasses,
    words,
    autoEscape
  });



  return (
    <span className="high-lighter">
      {
        textChunks.map(chunk => {
          const text = textToHighlight.substr(chunk.start, chunk.end - chunk.start);
          if (chunk.highlight) {
            return <span key={chunk.key} className={chunk.className}>
              {text}
            </span>;
          }
          return <span key={chunk.key} >
            {text}
          </span>;
        })
      }
    </span>
  );
};

export default Highlighter;
